
package org.clang.ast.aliases;

import org.clank.support.Converted;
import org.clang.ast.*;

// JAVA: Generated specialization

/// \brief Canonical proxy type returned when retrieving the members of a
/// canonical type or as the result of the @c CanQual<T>::getAs member
/// function.
///
/// The CanProxy type mainly exists as a proxy through which operator-> will
/// look to either map down to a raw T* (e.g., PointerType*) or to a proxy
/// type that provides canonical-type access to the fields of the type.
/*template <typename T> TEMPLATE*/
//<editor-fold defaultstate="collapsed" desc="clang::CanProxy<${TYPE}>">
@Converted(kind = Converted.Kind.MANUAL_ADDED/*Java specialization for ${TYPE}*/,
 source = "${LLVM_SRC}/llvm/tools/clang/include/clang/AST/CanonicalType.h", line = 332,
 FQN="clang::CanProxy<${TYPE}>", NM="_ZN5clang8CanProxyE",
 cmd="jclank.sh -java-options=${SPUTNIK}/modules/org.clang.ast/llvmToClangType ${LLVM_SRC}/llvm/tools/clang/lib/CodeGen/CGAtomic.cpp -nm=_ZN5clang8CanProxyE")
//</editor-fold>
public class ${FILE_NAME}  extends /*public*/ CanProxyAdaptor${TYPE} implements CanProxy<${TYPE}>{
/*public:*/
  /// \brief Build a NULL proxy.
  //<editor-fold defaultstate="collapsed" desc="clang::CanProxy::CanProxy<T>">
  @Converted(kind = Converted.Kind.MANUAL_ADDED,
   source = "${LLVM_SRC}/llvm/tools/clang/include/clang/AST/CanonicalType.h", line = 336,
   FQN="clang::CanProxy<${TYPE}>::CanProxy<${TYPE}>", NM="_ZN5clang8CanProxyC1Ev",
   cmd="jclank.sh -java-options=${SPUTNIK}/modules/org.clang.ast/llvmToClangType ${LLVM_SRC}/llvm/tools/clang/lib/CodeGen/CGAtomic.cpp -nm=_ZN5clang8CanProxyC1Ev")
  //</editor-fold>
  public ${FILE_NAME}() {
  }

  
  /// \brief Build a proxy to the given canonical type.
  //<editor-fold defaultstate="collapsed" desc="clang::CanProxy::CanProxy<T>">
  @Converted(kind = Converted.Kind.MANUAL_ADDED,
   source = "${LLVM_SRC}/llvm/tools/clang/include/clang/AST/CanonicalType.h", line = 339,
   FQN="clang::CanProxy<${TYPE}>::CanProxy<${TYPE}>", NM="_ZN5clang8CanProxyC1ENS_7CanQualIT_EE",
   cmd="jclank.sh -java-options=${SPUTNIK}/modules/org.clang.ast/llvmToClangType ${LLVM_SRC}/llvm/tools/clang/lib/CodeGen/CGAtomic.cpp -nm=_ZN5clang8CanProxyC1ENS_7CanQualIT_EE")
  //</editor-fold>
  public ${FILE_NAME}(CanQual<${TYPE}> Stored) {
    this.Stored = Stored;
  }

  
  /// \brief Implicit conversion to the stored canonical type.
  //<editor-fold defaultstate="collapsed" desc="clang::CanProxy::operator CanQual<type-parameter-0-0>">
  @Converted(kind = Converted.Kind.MANUAL_ADDED,
   source = "${LLVM_SRC}/llvm/tools/clang/include/clang/AST/CanonicalType.h", line = 342,
   FQN="clang::CanProxy<${TYPE}>::operator CanQual<type-parameter-0-0>", NM="_ZNK5clang8CanProxycvNS_7CanQualIT_EEEv",
   cmd="jclank.sh -java-options=${SPUTNIK}/modules/org.clang.ast/llvmToClangType ${LLVM_SRC}/llvm/tools/clang/lib/CodeGen/CGAtomic.cpp -nm=_ZNK5clang8CanProxycvNS_7CanQualIT_EEEv")
  //</editor-fold>
  public CanQual<${TYPE}> $CanQual$T() /*const*/ {
    return this.Stored;
  }

  @Converted(kind = Converted.Kind.MANUAL_ADDED/*overridden to have precize specialization as return type*/)
  @Override public /*const*/ CanProxyAdaptor${TYPE} /*P*/ $arrow() /*const*/ {
    return this;
  }
  
  @Override public String toString() {
    return "" + super.toString(); // NOI18N
  }
}
